﻿#--------------------------------------------
# Declare Global Variables and Functions here
#--------------------------------------------

#region xmlContent Entry XML Leer
[xml]$xmlEntryContent = @'
<?xml version="1.0" encoding="utf-8"?>
<inhalt>
  <elements>
  </elements>
</inhalt>
'@
#endregion

#Sample function that provides the location of the script
function Get-ScriptDirectory
{
<#
	.SYNOPSIS
		Get-ScriptDirectory returns the proper location of the script.

	.OUTPUTS
		System.String
	
	.NOTES
		Returns the correct path within a packaged executable.
#>
	[OutputType([string])]
	param ()
	if ($hostinvocation -ne $null)
	{
		Split-Path $hostinvocation.MyCommand.path
	}
	else
	{
		Split-Path $script:MyInvocation.MyCommand.Path
	}
}

#Sample variable that provides the location of the script
[string]$ScriptDirectory = Get-ScriptDirectory

function Check-FileDirsExist
{
	[CmdletBinding()]
	param (
		[Parameter(Position = 0, Mandatory = $true)]
		[System.String]$FileDirPath,
		[Parameter(Position = 1)]
		[System.String]$Name,
		[Parameter(Position = 2)]
		[System.String]$Type,
		[Parameter(Position = 3)]
		[System.String]$EntryType
	)
	begin
	{
		try
		{
		}
		catch [exception]{
			Write-Output $_.Exception.Message
			Exit 1
		}
	}
	process
	{
		try
		{
			switch ($Type)
			{
				file {
					if (!(Test-Path -Path "$FileDirPath\$Name"))
					{
						switch ($EntryType)
						{
							entry {
								$xmlEntryContent.Save("$FileDirPath\$Name")
							}
							config {
								$xmlConfigContent.Save("$FileDirPath\$Name")
							}
							default
							{
								#<code>
							}
						}
					}
					else
					{
						# Datei existiert bereits! --> Logging	
					}
				}
				dir {
					if (!(Test-Path -Path "$FileDirPath\$Name"))
					{
						New-Item -Path "$FileDirPath" -Name "$Name" -ItemType directory
					}
					else
					{
						# Verzeichnis existiert bereits! --> Logging!!
					}
				}
				default
				{
					#<code>
				}
			}
			
		}
		catch [exception]{
			Write-Output $_.Exception.Message
			Exit 1
		}
	}
	end
	{
		try
		{
		}
		catch [exception]{
			Write-Output $_.Exception.Message
			Exit 1
		}
	}
}

$global:ProgramFolder = "PHS_Library"

# Prüfen ob Verzeichnisse oder Files Existieren
Check-FileDirsExist -FileDirPath "C:\ProgramData" -Name $global:ProgramFolder -Type dir
Check-FileDirsExist -FileDirPath "C:\ProgramData\$global:ProgramFolder" -Name Entries.xml -Type file -EntryType entry

# Entry File laden
$global:xmlEntriesFileName = "Entries.xml"
$global:xmlEntriesFile = "C:\ProgramData\$global:ProgramFolder\Entries.xml"
$global:EntriesXML = New-Object xml
$global:EntriesXML.load("C:\ProgramData\$global:ProgramFolder\Entries.xml")


function Reset-EntryFile ($FileName)
{
	Remove-Item -Path "C:\ProgramData\$global:ProgramFolder\$FileName"
	Check-FileDirsExist -FileDirPath "C:\ProgramData\$global:ProgramFolder" -Name $FileName -Type file -EntryType entry
}
